#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 25;

int n, m;
int u, v;

int answer = 0;
vector <int> revGraph[MAXN];

bool used[MAXN];

void bruteForce(int pos)
{
    if(pos==n)
    {
        answer++;
    }

    for(int i = 1;i<=n;i++)
    {
        if(used[i]==false)
        {
            bool fail = false;
            for(int j = 0;j<revGraph[i].size();j++)
            {
                if(used[ revGraph[i][j] ]==false)
                {
                    fail = true;
                    break;
                }
            }

            if(fail==false)
            {
                used[i] = true;
                bruteForce(pos+1);
                used[i] = false;
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<m;i++)
    {
        cin >> u >> v;

        revGraph[v].push_back(u);
    }

    bruteForce(0);
    cout << answer << '\n';
}
