#include <iostream>
#include <queue>
#include <utility>
using namespace std;

pair < int, int > children [5000];
int level [5000];
int k [5000];

int main ()
{
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	for (int i = 0 ; i < m ; i ++)
	{
		int l, r = 0;
		cin >> l;
		if (l != -1) cin >> r;
		else l ++;

		children [i] = {l - 1, r - 1};
	}

	queue < pair < int, int > > q;
	q.push ({0, 1});
	level [0] = 0;
	
	while (not q.empty ())
	{
		auto f = q.front (); q.pop ();
		k [f.first] = f.second;
		if (children [f.first].first != -1)
		{
			level [children [f.first].first] = level [f.first] + 1;
			q.push ({children [f.first].first, f.second * 2});
		}
		if (children [f.first].second != -1)
		{
			level [children [f.first].second] = level [f.first] + 1;
			q.push ({children [f.first].second, f.second * 1});
		}
	}
	for (int i = 0 ; i < n ; i ++)
		cout << k [i] << " ";
}

