#include<iostream>
#include<vector>
#define MOD 1000000007
using namespace std;
vector<int>susedi[100002];
int suscnt[100002];
long long facts[100002];
long long mpow(long long a,long long b){
    if(b==1){
        return a;
    }
    long long m=mpow(a,b/2);
    if(b%2==0){
        return m*m%MOD;
    }else{
        return (m*m%MOD)*a%MOD;
    }
}
long long comb(long long a,long long b){
    long long ans=facts[a];//facts[b]/facts[a-b];
    ans=ans*mpow(facts[b],MOD-2)%MOD;
    ans=ans*mpow(facts[a-b],MOD-2)%MOD;
    return ans;
}
bool visited[100002];
pair<long long,long long>dfs(int v){
    if(visited[v]){
        return {-1,-1};
    }
    visited[v]=1;
    //cout<<v<<endl;
    long long mult=1,siz=0;
    vector<long long> anses;
    for(int i=0;i<susedi[v].size();i++){
        suscnt[susedi[v][i]]--;
    }
    for(int i=0;i<susedi[v].size();i++){
        //suscnt[susedi[v][i]]--;
        if(suscnt[susedi[v][i]]==0){
            pair<long long,long long>curr=dfs(susedi[v][i]);
            if(curr.first==curr.second && curr.first==-1){
                continue;
            }
            anses.push_back(curr.second);
            siz+=curr.second;
            mult*=curr.first;
            mult%=MOD;
        }
    }
    long long ans=mult;
    long long sizb=siz;
    //cout<<v<<" "<<siz<<endl;
    for(int i=0;i<anses.size();i++){
        ans=ans*comb(siz,anses[i]);
        ans%=MOD;
        siz-=anses[i];
    }
    //cout<<v<<endl;
    return {ans,sizb+1};
}
int main(){
    facts[0]=1;
    facts[1]=1;
    for(int i=2;i<=100000;i++){
        facts[i]=facts[i-1]*i;
        facts[i]%=MOD;
    }
    int n,m;
    cin>>n>>m;
    //cout<<comb(n,m)<<endl;
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        susedi[a].push_back(b);
        suscnt[b]++;
    }
    for(int i=1;i<n;i++){
        susedi[0].push_back(i);
        suscnt[i]++;
    }
    cout<<dfs(0).first<<endl;
    return 0;
}
