#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 100000;
const int MAXM = 200000;
const int MOD = 1000000007;
int n, m;
struct sth
{
    int ind;
    int chn;
    vector<int> ch;
};
sth a[MAXN+100];
long long var;

void input()
{
    int temp, temp2;
    cin>>n>>m;
    for (int i=0; i<n; i++)
    {
        a[i].ind = i;
    }
    for (int i=0; i<m; i++)
    {
        cin>>temp>>temp2;
        temp--;
        temp2--;
        a[temp].chn++;
        a[temp].ch.push_back(temp2);
    }
}

void output()
{
    cout<<var<<endl;
}

int recursion(int check, sth p[], int t)
{
    //cerr<<p[check].ind<<" - ";
    if (t==1) return 1;
    long long cc = 0;
    int used[n+1];
    vector<int> top;
    for (int i=0; i<t; i++)
    {
        used[p[i].ind] = 0;
    }
    for (int i=0; i<t; i++)
    {
        for (int j=0; j<p[i].chn; j++)
        {
            //cout<<p[i].ch[j]
            used[p[i].ch[j]] = 1;
        }
    }
    for (int i=0; i<t; i++)
    {
        if (!used[p[i].ind]) top.push_back(i);
    }
    for (int i=0; i<top.size(); i++)
    {
        swap (p[t-1], p[top[i]]);
        cc += recursion(top[i], p, t-1);
        cc %= MOD;
        //cerr<<check+1<<" uspeshno4 ";
    }
    return cc;
}

void solve()
{
    var = recursion(-1, a, n);
}

int main()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    input();
    solve();
    output();
    return 0;
}

/*
6 7
1 2
1 3
2 3
3 4
2 4
3 5
2 6

4 2
1 2
3 4
*/

