#include<iostream>
#include<algorithm>
#include<stdio.h>
#include<vector>

using namespace std;

const int MAXN = 5000;
int n, m;

struct children
{
    int l, r;
    int lc, rc;
};
children p[MAXN+100];
vector<unsigned long long> ch;
unsigned long long chance;

void input()
{
    cin>>n>>m;
    for (int i=0; i<n; i++)
    {
        cin>>p[i].l;
        if (p[i].l != -1)
        {
            cin>>p[i].r;
            p[i].l--;
            p[i].r--;
        }
    }
}

void output()
{
    cout<<"0."<<chance<<endl;
}

int dfs(int curr, int depth)
{
    int temp1, temp2;
    //cerr<<curr+1<<' ';
    if (p[curr].l == -1)
    {
        return 1000000000000000/depth;
    }
    else
    {
        temp1 = dfs(p[curr].l, depth+1);
        temp2 = dfs(p[curr].r, depth+1);
        if (temp1>temp2)
        {
            p[curr].lc = 2;
            p[curr].rc = 1;
        }
        else
        {
            p[curr].lc = 1;
            p[curr].rc = 2;
        }
    }
    return (temp1*p[curr].lc/3 + temp2*p[curr].rc/3);
}

int dfs2(int curr, long long pch)
{
    if (p[curr].l == -1)
    {
        ch.push_back(pch);
    }
    else
    {
        dfs2(p[curr].l,  (long long)pch*p[curr].lc/3);
        dfs2(p[curr].r,  (long long)pch*p[curr].rc/3);
    }
}

void solve()
{
    chance = 0;
    if (n==1)
    {
        chance = 1;
        return;
    }
    dfs(0, 0);
    dfs2(0, 10000000000000);
    sort(ch.begin(), ch.end());
    int sz = ch.size()-1;
    for (int i=0; i<m; i++)
    {
        chance += ch[sz-i];
    }
}

int main()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    input();
    solve();
    output();
    return 0;
}

/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1



13 2
2 3
4 5
6 7
8 9
-1
10 11
-1
-1
12 13
-1
-1
-1
-1

13 2
9 12
-1
-1
13 11
-1
-1
8 5
-1
10 3
2 7
-1
4 6
-1
*/
