#include<iostream>
#include<algorithm>
#include<vector>

using namespace std;

const int MAXN = 5000;
int n, m;

struct children
{
    int l, r;
    long long curr_chance;
};
children p[MAXN+100];
vector<long long> ch;
long long chance;

void input()
{
    cin>>n>>m;
    for (int i=0; i<n; i++)
    {
        cin>>p[i].l;
        if (p[i].l != -1)
        {
            cin>>p[i].r;
            p[i].l--;
            p[i].r--;
        }

    }
}

void output()
{
    cout<<"0."<<chance/10<<endl;
}

int dfs(int curr, long long pch)
{
    p[curr].curr_chance = pch;
    if (p[curr].l == -1)
    {
        ch.push_back(pch);
    }
    else
    {
        dfs(p[curr].l,  (long long)pch*2/3);
        dfs(p[curr].r,  (long long)pch*1/3);
    }
}

void solve()
{
    dfs(0, 1000000000);
    sort(ch.begin(), ch.end());
    int sz = ch.size()-1;
    for (int i=0; i<m; i++)
    {
        chance += ch[sz-i];
    }
}

int main()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    input();
    solve();
    output();
    return 0;
}

/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/
