#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int TREE_SIZE = 262144;

int n;
vector<int> a;

void read() {
    cin >> n;
    a.reserve(n);
    for (int i = 0; i < n; i++) {
        int ai;
        cin >> ai;
        a.push_back(ai);
    }
}

int tree[TREE_SIZE];

void build(int idx, int low, int high) {
    if (low == high) {
        tree[idx] = 1;
        return;
    }
    int mid = (low + high) >> 1;
    build(idx << 1, low, mid);
    build(idx << 1 | 1, mid + 1, high);
    if (a[mid] != a[mid + 1]) tree[idx] = tree[idx << 1] + tree[idx << 1 | 1];
    else tree[idx] = tree[idx << 1] + tree[idx << 1 | 1] - 1;
}

void update(int idx, int low, int high, int index, int color) {
    if (low == high) {
        a[low] = color;
        return;
    }
    int mid = (low + high) >> 1;
    if (index >= low && index <= mid) update(idx << 1, low, mid, index, color);
    else update(idx << 1 | 1, mid + 1, high, index, color);
    if (a[mid] != a[mid + 1]) tree[idx] = tree[idx << 1] + tree[idx << 1 | 1];
    else tree[idx] = tree[idx << 1] + tree[idx << 1 | 1] - 1;
}

void solve() {
    build(1, 0, n - 1);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            a.erase(next(a.begin(), k - 1));
            n--;
        } else if (type == 2) {
            int p, c;
            cin >> p >> c;
            a.insert(next(a.begin(), p - 1), c);
            n++;
        } else if (type == 3) {
            int q, s;
            cin >> q >> s;
            q--;
            update(1, 0, n - 1, q, s);
        } else if (type == 4) cout << tree[1] << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}
