#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXL=5024;
int n, m, childr[MAXL][2], chance[MAXL], depth[MAXL];
int dmin=5024;

void calc(int p, int d)
{
    depth[p]=d;

    int l=childr[p][0];
    int r=childr[p][1];
    if(l==(-1))
    {
        if(dmin>d) dmin=d;
        return;
    }

    chance[l]=chance[p]+1;
    chance[r]=chance[p];

    calc(l, d+1);
    calc(r, d+1);
}

bool cmp(double x, double y)
{
    return x>y;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>m;

    int l, r, leaves=0;
    for(int i=1; i<=n; ++i)
    {
        cin>>l;

        if(l==(-1))
        {
            leaves++;
            childr[i][0]=(-1);
            continue;
        }

        cin>>r;

        childr[i][0]=l;
        childr[i][1]=r;
    }

    calc(1, 0);

    vector<double> chances;
    for(int i=1; i<=n; ++i)
    {
        if(childr[i][0]!=(-1)) continue;

        int heads, tails;
        heads=chance[i];
        tails=depth[i]-heads;
        double h=1;
        int c=heads;
        while(c)
        {
            h=h*2;
            h=h/3;
            c--;
        }

        double t=1;
        c=tails;
        while(c)
        {
            t/=3;
            c--;
        }

        double r=h*t;
        r/=(depth[i]-dmin+1);
        //cout<<i<<" "<<heads<<" "<<tails<<" "<<h<<" "<<t<<" "<<r<<endl;
        chances.push_back(r);
    }

    sort(chances.begin(), chances.begin()+leaves, cmp);

    double answ=0;
    for(int i=0; i<m; ++i)
    {
        answ+=chances[i];
        //cout<<chances[i]<<endl;
    }

    cout<<fixed<<setprecision(8)<<answ<<endl;

    return 0;
}

/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1

---
13 4
2 3
4 5
6 7
-1
-1
8 9
10 11
-1
-1
12 13
-1
-1
-1

*/
