#include<iostream>
#include<vector>
#include<utility>
#include<algorithm>
using namespace std;
#define MAXN 5000
pair<int,int> G[MAXN+1];
long double Gs[MAXN+1];
int i,j,n,m,a,b;
const pair<int,int> NULLPAIR=make_pair(0,0);
double pow(double p,int x)
{
	if(x==0)return 1;
	if(x==1)return p;
	if(x%2==0)return pow(p*p,x/2);
	return p*pow(p,x-1);
}
double R(pair<int,int> p)
{
	return pow(2.0/3.0,p.first)*pow(1.0/3.0,p.second);
}
void dfs(int i,pair<int,int> p=NULLPAIR)
{
	if(G[i]==NULLPAIR)
	{
		Gs[i]=R(p);
		return;
	}
	p.first++;
	dfs(G[i].first,p);
	p.first--;
	p.second++;
	dfs(G[i].second,p);
}
int main()
{
	long double r=0.0;
	cin>>n>>m;
	for(i=1;i<=n;i++)
	{
		Gs[i]=0.0;
		cin>>a;
		if(a==-1)
		{
			G[i]=NULLPAIR;
			continue;
		}
		cin>>b;
		G[i]=make_pair(a,b);
	}
	dfs(1);
	sort(Gs+1,Gs+n);
	for(i=2;i<=m+1;i++)
		r+=Gs[n-i+1]; 
	cout<<r<<endl;
	return 0;
}
