#include <iostream>
#include <vector>
using namespace std;
void build();
void del(int k);
void ins(int p, int c);
void rep(int q, int s);
void print();
int get_last_left(int x);
int get_last_right(int x);

int n, t;
const int MAXNT = 200001;///200 001
vector <int> a;
int sum;

void ins(int p, int c) {
    --p;
    a.insert(a.begin() + p, c);
    for(int i = 0; i < a.size(); ++i) {
        cout << a[i] << " ";
    }
    cout << endl;
    int left = get_last_left(p);
    int right = get_last_right(p);
    if(c != left && c != right) {
        if(left == right && left != -1) {
            --sum;
        }
        else
            ++sum;
    }
}

int main() {
    cin >> n;
    for(int i = 0; i < n; ++i) {
        int inp;
        cin >> inp;
        a.push_back(inp);
    }
    build();
    cin >> t;
    for(int i = 0; i < t; ++i) {
        int arg1, arg2, arg3;
        cin >> arg1;
        if(arg1 == 1) {
            cin >> arg2;
            del(arg2);
        }
        else if(arg1 == 2) {
            cin >> arg2 >> arg3;
            ins(arg2, arg3);
        }
        else if(arg1 == 3) {
            cin >> arg2 >> arg3;
            rep(arg2, arg3);
        }
        else if(arg1 == 4) {
            print();
        }
    }
    return 0;
}


void del(int k) {
    --k;
    int left = get_last_left(k);
    int right = get_last_right(k);
    if(left != a[k] && right != a[k] ) {
        --sum;
        if(left == right && left != -1)
            --sum;
    }
    a.erase(a.begin() + k);
}

void rep(int q, int s) {
    --q;
    int left = get_last_left(q);
    int right = get_last_right(q);
    if(a[q] != s) {
        if(a[q] == left && a[q] == right) {
            ++sum;
        }
        else if(a[q] == left) {
            if(s != right)
                ++sum;
        }
        else if(a[q] == right) {
            if(s != left) {
                ++sum;
            }
        }
        else if(a[q] != right && a[q] != left) {
            if(s == left && s == right) {
                --sum;
            }
        }
    }
    a[q] = s;
}

void print() {
    cout << sum << endl;
}

int get_last_left(int x) {
    if(x < 0) {
        return -1;
    }
    return a[x - 1];
}

int get_last_right(int x) {
    if(x >= n) {
        return -1;
    }
    return a[x + 1];
}

void build() {
    ++sum;
    for(int i = 1; i < n; ++i) {
        if(a[i] != a[i - 1])
            ++sum;
    }
}
