#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m;
const int MAXN = 5024;
struct node {
    bool is_leaf = false;
    int left;
    int right;
};
node tree[MAXN];
priority_queue<unsigned long long> q;
bool is_leaf[MAXN];
int leaves[MAXN];
int num_lefts[MAXN];
int num_leaves = 0;

void solve(int cur, int num_lefts, int num_rights) {
    //cout << cur << endl;
    if(tree[cur].is_leaf) {
        unsigned long long znm = pow(3, num_lefts + num_rights);
        unsigned long long chsl = 1 << num_lefts;
        double rslt = (chsl * 100000) / (znm * 100000);
        //cout << rslt << " " << chsl << " " << znm << " " << cur << " " << num_lefts << " " << num_rights<<  endl;
        //cout << chsl*1000000000 << " " << znm*10000000 << endl;
        //cout << (chsl*1000000000) / (znm) << endl;
        q.push((chsl*1000000000) / (znm));
        return;
    }
    else {
        solve(tree[cur].left, num_lefts + 1, num_rights);
        solve(tree[cur].right, num_lefts, num_rights + 1);
    }
}

int main() {
    cin >> n >> m;
    for(int i = 1; i <= n; ++i) {
        int left, right;
        cin >> left;
        if(left != -1) {
            cin >> right;
            tree[i].left = left;
            tree[i].right = right;
        }
        else {
            tree[i].is_leaf = true;
        }
    }
    solve(1, 0, 0);
    double ans = 0;
    for(int i = 0; i < m; ++i) {
        ans += q.top();
        //cout << q.top() << endl;
        q.pop();
    }
    //cout << ans* 10000 << endl;
    //cout << fixed << ans << endl;
    cout <<double(ans / 1000000000.0) << endl;
    return 0;
}
