#include<iostream>
#include<vector>
#include<algorithm>
#include<iomanip>
using namespace std;
struct tree{
    double siz,dep,leafs;
    double avlen;
};
int susedi[5000][2];
tree trees[5000];
tree dfs(int v){
    tree ans;
    if(susedi[v][0]){
        ans={1,1,1,0};
    }else{
        tree t1=dfs(susedi[v][0]),t2=dfs(susedi[v][1]);
        ans.siz=t1.siz+t2.siz+1;
        ans.dep=max(t1.dep,t2.dep)+1;
        ans.leafs=t1.leafs+t2.leafs;
        ans.avlen=(t1.avlen*t1.leafs+t2.avlen*t2.leafs)/(t1.leafs+t2.leafs)+1;
    }
    trees[v]=ans;
    return ans;
}
vector<double>anses;
void paths(int v,double c){
    if(susedi[v][0]==-1){
        anses.push_back(c);
    }else{
        double w1,w2;
        if(trees[susedi[v][0]].avlen>trees[susedi[v][1]].avlen){
            w1=1.0/3.0;
            w2=2.0/3.0;
        }else{
            w1=2.0/3.0;
            w2=1.0/3.0;
        }
        paths(susedi[v][0],c*w1);
        paths(susedi[v][1],c*w2);
    }
}
int main(){
    int n,m;
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        int a,b;
        cin>>a;
        if(a==-1){
            b=a;
        }else{
            cin>>b;
        }
        susedi[i][0]=a;
        susedi[i][1]=b;
    }
    dfs(1);
    paths(1,1);
    double ans=0;
    sort(anses.begin(),anses.end());
    for(int i=0;i<m;i++){
        ans+=anses[anses.size()-1-i];
    }
    cout<<fixed<<setprecision(9)<<ans<<endl;
    return 0;
}
