#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 100000;
const int MOD = 1000000007;
int n, m;
vector<int> a[MAXN+100];
long long var;

void input()
{
    int temp, temp2;
    cin>>n>>m;
    for (int i=0; i<m; i++)
    {
        cin>>temp>>temp2;
        temp--;
        temp2--;
        a[temp].push_back(temp2);
    }
}

void output()
{
    cout<<var<<endl;
}

int recursion(int check, vector<int> p[], int u[], int t)
{
    //cerr<<check<<' ';
    if (t==1)
    {
        return 1;
    }
    long long cc = 0;
    int used[n+1];
    vector<int> top;
    for (int i=0; i<n; i++)
    {
        used[i]=0;
        if (u[i]) used[i]=1;
    }
    for (int i=0; i<n; i++)
    {
        if (u[i]) continue;
        for (int j=0; j<p[i].size(); j++)
        {
            used[p[i][j]] = 1;
        }
    }
    for (int i=0; i<n; i++)
    {
        if (!used[i]) top.push_back(i);
    }
    for (int i=0; i<top.size(); i++)
    {
        u[top[i]] = 1;
        cc += recursion(top[i], p, u, t-1);
        cc %= MOD;
        //cerr<<check+1<<" uspeshno4 ";
        u[top[i]] = 0;
    }
    return cc;
}

void solve()
{
    int u[n+1];
    for (int i=0; i<=n; i++)
    {
        u[i] = 0;
    }
    var = recursion(-1, a, u, n);
}

int main()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    input();
    solve();
    output();
    return 0;
}

/*
6 7
1 2
1 3
2 3
3 4
2 4
3 5
2 6

4 2
1 2
3 4
*/

