#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 100000;
const int MOD = 1000000007;
int n, m;
struct node
{
    vector<int> par;
    vector<int> ch;
};
node a[MAXN+100];
long long var;

void input()
{
    int temp, temp2;
    cin>>n>>m;
    for (int i=0; i<m; i++)
    {
        cin>>temp>>temp2;
        temp--;
        temp2--;
        a[temp].ch.push_back(temp2);
        a[temp2].par.push_back(temp);
    }
}

void output()
{
    cout<<var<<endl;
}

int recursion(int last, node p[], vector<int> top, vector<int> fg, int t)
{
    fg.push_back(last);
    //cerr<<last<<' '<<t<<endl;
    if (t==1) return 1;
    int temp, temp2, temp3;
    for (int i=0; i<p[last].ch.size(); i++)
    {
        temp = p[last].ch[i];
        //if (t==3 && last==2) cerr<<temp<<" - "<<p[temp].par.size()<<endl;
        temp3 = 1;
        for (int j=0; j<p[temp].par.size(); j++)
        {
            temp2 = 0;
            for (int z=0; z<fg.size(); z++)
            {
                if (p[temp].par[j]==fg[z])
                {
                    temp2 = 1;
                    break;
                }
            }
            if (!temp2)
            {
                temp3 = 0;
                break;
            }
        }
        if (temp3) top.push_back(temp);
    }

    //if (t==3 && last==2)
        //for (int i=0; i<top.size(); i++) cerr<<top[i]<<' ';

    long long cc = 0;
    for (int i=0; i<top.size(); i++)
    {
        //cerr<<last<<' '<<t<<" - "<<top[i]<<endl;
        temp = top[i];
        swap(top[i], top[top.size()-1]);
        top.pop_back();
        cc += recursion(temp, p, top, fg, t-1);
        cc %= MOD;
        top.push_back(temp);
        swap(top[i], top[top.size()-1]);
    }
    return cc;
}

void proverka_na_vhoda()
{
    for (int i=0; i<n; i++)
    {
        cerr<<i<<" - ";
        for (int j=0; j<a[i].ch.size(); j++)
        {
            cerr<<a[i].ch[j]<<' ';
        }
        cerr<<" - ";
        for (int j=0; j<a[i].par.size(); j++)
        {
            cerr<<a[i].par[j]<<' ';
        }
        cerr<<endl;
    }
}

void solve()
{
    int temp;
    if (n==1)
    {
        var = 1;
        return;
    }
    int used[n+1];
    vector<int> top;
    for (int i=0; i<n; i++)
    {
        used[i]=0;
    }
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<a[i].ch.size(); j++)
        {
            used[a[i].ch[j]] = 1;
        }
    }
    for (int i=0; i<n; i++)
    {
        if (!used[i]) top.push_back(i);
    }
    //cerr<<endl;
    for (int i=0; i<top.size(); i++)
    {
        temp = top[i];
        swap(top[i], top[top.size()-1]);
        top.pop_back();
        var += recursion(temp, a, top, {}, n-1);
        var %= MOD;
        top.push_back(temp);
        swap(top[i], top[top.size()-1]);
    }
}

int main()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    input();
    solve();
    output();
    return 0;
}

/*
6 7
1 2
1 3
2 3
3 4
2 4
3 5
2 6

4 2
1 2
3 4
*/

