#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 21;
const int MOD = (int)1e9 + 7;

int n, m;
vector<int> graph[MAXN];
int din[MAXN];

void read() {
    cin >> n >> m;
    memset(din, 0, sizeof(din));
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        graph[y].push_back(x);
        din[y]++;
    }
}

int order[MAXN];

void solve() {
    int ans = 0;
    for (int i = 1; i <= n; i++) order[i] = i;
    do {
        if (din[order[1]]) continue;
        bool ok = true;
        for (int i = n; i >= 2; i--) {
            if (!din[order[i]]) continue;
            bool flag = true;
            for (int parent : graph[order[i]]) {
                bool found = false;
                for (int j = 1; j < i; j++) {
                    if (order[j] == parent) {
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    flag = false;
                    break;
                }
            }
            if (!flag) {
                ok = false;
                break;
            }
        }
        if (ok) ans = (ans + 1) % MOD;
    } while (next_permutation(order + 1, order + n + 1));
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}
