#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 21;
const int MOD = (int)1e9 + 7;

int n, m;
vector<int> graph[MAXN];
int din[MAXN];

void read() {
    cin >> n >> m;
    memset(din, 0, sizeof(din));
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        graph[y].push_back(x);
        din[y]++;
    }
}

set<int> order;
bool used[MAXN];
int ans = 0;

bool can_put(int node, int idx) {
    if (!din[node]) return true;
    for (int parent : graph[node]) {
        if (!order.count(parent)) return false;
    }
    return true;
}

void f(int idx) {
    if (idx == n) {
        ans = (ans + 1) % MOD;
        return;
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i] && can_put(i, idx)) {
            used[i] = true;
            order.insert(i);
            f(idx + 1);
            order.erase(i);
            used[i] = false;
        }
    }
}

void solve() {
    memset(used, false, sizeof(used));
    f(0);
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}
