#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MOD=1000000007;

int n, m;
vector<int> g[124];
int c[124];
bool visited[124];

long long answ=0;
stack<int> sol;

void solve(int i, int used)
{
    //cout<<i<<" "<<used<<endl;
    visited[i]=true;

    if(used==n)
    {
        answ=(answ+1)%MOD;
        visited[i]=false;
        return;
    }

    for(int j=0; j<g[i].size(); ++j)
    {
        int nxt=g[i][j];
        c[nxt]--;
    }

    for(int j=1; j<=n; ++j)
    {
        //cout<<j<<" "<<c[j]<<" "<<visited[j]<<endl;
        if(c[j]==0 && !visited[j])
        {
            solve(j, used+1);
        }
    }
    //cout<<endl;

    for(int j=0; j<g[i].size(); ++j)
    {
        int nxt=g[i][j];
        c[nxt]++;
    }

    visited[i]=false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>m;

    int x, y;
    for(int i=1; i<=m; ++i)
    {
        cin>>x>>y;
        g[x].push_back(y);
        c[y]++;
    }

    for(int i=1; i<=n; ++i)
    {
        if(c[i]==0) {g[0].push_back(i); c[i]++;}
    }

    solve(0, 0);

    cout<<answ%MOD<<endl;

    return 0;
}

/*

6 7
1 2
1 3
2 3
3 4
2 4
3 5
2 6

4 2
1 2
3 4

*/
