#include<bits/stdc++.h>
using namespace std;

struct fraction
{
    int a;
    int b;
};

struct neuron
{
    int l ;
    int r ;
    int row;
    int n_r;
    fraction prob;
};

int n,m;
vector<neuron> tree;

bool f(neuron x,neuron y)
{
    if(x.l==-1&&y.l!=-1)return true;
    if(x.l==-1&&y.l!=-1)return false;
    if(x.l!=-1&&y.l!=-1)return true;
    long double dprobx = (long double)x.prob.a/(long double)x.prob.b;
    long double dproby = (long double)y.prob.a/(long double)y.prob.b;
    if(dprobx > dproby)return true;
    return false;
}
fraction addition(fraction x,fraction y)
{
    fraction result;
    if(x.b == y.b)
    {
        result.a = x.a + y.a;
        result.b = x.b;
        return result;
    }
    else
    {
        result.a = x.a*y.b + y.a*x.b;
        result.b = x.b*y.b;
        return result;
    }
}
long double solve()
{
    fraction raw;
    raw = tree[0].prob;
    for(int i=1;i<m;i++)
    {
        raw = addition(raw,tree[i].prob);
        //cout<<raw.a<<"/"<<raw.b<<endl;
    }
    return (long double)raw.a/(long double)raw.b;
}

void fillprob()
{
    for(int i=0;i<n;i++)
    {
        if(tree[i].l<0||tree[i].r<0)continue;

        fraction current = tree[i].prob;
        fraction lf;
        lf.a = current.a*2;
        lf.b = current.b*3;
        fraction rf;
        rf.a = current.a;
        rf.b = current.b*3;
        tree[tree[i].l-1].prob = lf;
        tree[tree[i].r-1].prob = rf;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n>>m;

    fraction init;
    init.a=1;
    init.b=1;

    for(int i=0;i<n;i++)
    {
        neuron p;
        cin>>p.l;
        if(p.l != -1)cin>>p.r;
        if(tree.empty())
        {
            p.prob = init;
        }
        tree.push_back(p);
    }
    fillprob();

    sort(tree.begin(),tree.end(),f);

    cout<<solve()<<endl;

    return 0;
}
