#include <iostream>
#include <vector>
using namespace std;

int n, m;
const int MAXN = 100001;///100 001
const int MAXM = 200000;///200 000
vector<int> a[MAXN];
int ans;

bool used_template[MAXN];

void solve(bool used[], int num_used) {
    if(num_used + 1 == n) {
        ++ans;
        return;
    }
    vector <int> v;
    for(int i = 1; i <= n; ++i) {
        if(!used[i]) {
            bool userful = true;
            for(int j = 0; j < a[i].size() && userful; ++j) {
                if(!used[a[i][j]]) {
                    userful = false;
                }
            }
            if(userful)
                v.push_back(i);
        }
    }
    for(int i = 0; i < v.size(); ++i) {
        //cout << v[i] << endl;
        used[v[i]] = true;
        solve(used, num_used + 1);
        used[v[i]] = false;
    }
}

int main() {
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        int from, to;
        cin >> from >> to;
        a[to].push_back(from);
    }
    bool used[MAXN];
    for(int i = 1; i < MAXN; ++i) {
        used[i] = 0;
    }
    solve(used, 0);
    cout << ans << endl;
    return  0;
}
