#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 5003
using namespace std;
int n, m;
vector <int> v[MAXN];
double prb[MAXN];
bool b[MAXN];
bool root[MAXN];

void input()
{
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x;
        if (x == -1)
        {
            b[i] = 1;
            continue;
        }
        cin >> y;
        v[i].push_back(x - 1);
        v[i].push_back(y - 1);
        root[x-1] = 1;
        root[y-1] = 1;
    }
}

void dfs(int tmp)
{
    if (v[tmp].size() == 0)
        return;
    prb[v[tmp][0]] = prb[tmp] * 2 / 3;
    dfs(v[tmp][0]);
    prb[v[tmp][1]] = prb[tmp] * 1 / 3;
    dfs(v[tmp][1]);
}

struct st
{
    double val;
    int id;
    bool leaf;
    st (double _val, int _id, bool _leaf)
    {
        val = _val;
        id = _id;
        leaf = _leaf;
    }
    bool operator < (const st &p) const
    {
        return val > p.val;
    }
};

vector <st> d;
double ans = 0.0;

void calc()
{
    int rt;
    for (int i = 0; i < n; ++i)
        if (!root[i])
            rt = i;
    prb[rt] = 1;
    dfs(rt);
    for (int i = 0; i < n; ++i)
    {
        //cout << prb[i] << endl;
        if (b[i])
            d.push_back(st(prb[i], i, 1));
    }
    sort(d.begin(), d.end());
    for (int i = 0; i < min(m, (int)d.size()); ++i)
        ans += d[i].val;
    cout << fixed;
    cout << setprecision(8) << ans << endl;
}

/**
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    input();
    calc();

    return 0;
}
